/*this is my expert system*/
%race
domains
	list=string*
constants
	file="episode.dba"
	enterprise=["                                                _+_","                                  ____..---=====   ========-..____"," __________________ __         ,-='=====____ = _ = = - _ = = _____==`=","(.__         ______I__)/ - _-=_/    `------=_=-------'","    /    /__...---==='---+---_'","   '----'---.___ = _ = = _.-'","                `-------'"]
database
	episode(string,string)
	count(integer)
	episodelow(string,string)
	
predicates
	printcommands
	print_ent
	printlist(list)
	song(integer,string)
	getsong
	search(string)
	go
	listpossible
	query(string)
	lowerall
		
clauses 
	song(1,"one.exe").
	song(2,"two.exe").
	song(3,"three.exe").
	song(0,"four.exe").
	
	lowerall if
		episode(A,B),
		upper_lower(B,C),
		assert(episodelow(A,C)),
		retract(episode(A,B)),
		fail.
	lowerall.
	
	go if
		gotowindow(2),
		clearwindow,
		asserta(count(0)),
		listpossible,
		gotowindow(1),
		write("What do you know?"),
		readln(String),
		upper_lower(String,Strin),
		!,
 		search(Strin),		
		gotowindow(2),
		query(Strin),
		!,
		go.
		
	query("reset") if
		retractall(episodelow(_,_)),
		consult(file),
		lowerall.
	query("quit") if
		exit.
	query("exit") if
		exit.
	query("internet") if
		system("start http://www.astro.virginia.edu/~eww6n/startrek/StarTrekAll.html"),
		printcommands,
		query("reset").
	query(_).
	
	search(This) if 
		not(This="quit"),
		episodelow(_,Here),
		not(searchstring(Here,This,_)),
		retract(episodelow(_,Here)),		
		fail.
	search(_).
	
	listpossible if
		episodelow(Name,_),			
		count(Num),
		Num+1=Number,
		retractall(count(_)),
		asserta(count(Number)),
		nl,
		write(Name),
		fail.
	listpossible if
		cursor(0,35),
		count(Number),
		write(Number).
	
	getsong if
		random(4,Num),
		song(Num,Song),
		system(Song).
		
	print_ent if
		printlist(enterprise),	write("press any key to continue").
	printlist([]).
	printlist([H|T]) if
		write(H,"\n"),
		printlist(T).
	
	printcommands if
		gotowindow(3),
		clearwindow,
		write("Quit\nExit\nReset\nInternet").

goal
	%system("a:"),
	makewindow(5,1,4,"Star Trek: The Original Series, episode guide",0,0,25,80),
	nl,
	print_ent,
	readchar(_),
	getsong,
	retractall(episode(_,_)),
 	consult(file),
	makewindow(6,1,0,"Elim",24,79,1,1),
 	makewindow(2,2,4,"Possible Episodes",2,40,22,39),
	makewindow(3,3,4,"Commands",13,1,11,39),
	makewindow(1,5,4,"Search window",2,1,11,39),
	printcommands,
	lowerall,
	go.